#!/usr/local/bin/python2.2

import jon.cgi as cgi
import os.path
import os
import fax
import string
from time import gmtime, strftime
from Cheetah.Template import Template


class Archive:
    def __init__(self, req, File):
	self.req 	= req
	self.file 	= File
    
    def choose(self):
	years		= self.file.listDir(self.file.backup)
	list		= self.file.listDir(self.file.temp)
	
	if 'year' in self.req.params:
	    sel_year = self.req.params['year']
	else:
	    sel_year = 0
	    
	if 'month' in self.req.params:
	    sel_month = self.req.params['month']
	else:
	    sel_month = 0
	
	archive 		= Template(file=self.file.template + "archive.tmpl")
	archive.years		= years
	archive.sel_year 	= sel_year
	archive.sel_month 	= sel_month
	archive.list		= list
	self.req.write(archive)	
	return
	
    def show(self, faxes):
	archive = {}
	for fax in faxes:
	    if faxes[fax] != []:
		for txt in faxes[fax][1]:
		    data 	= fax + txt 
		    file 	= self.file.open(data)
		    # change 4 into the lenght of your txtExt
		    pic 	= data[:-4] + self.file.picExt
		    strip	= self.file.split(pic)
		    temp	= self.file.listDir(self.file.temp)
		    cnt		= len(archive)
		    if strip[-1] not in temp:
			pic = self.file.split(pic)
			pic = self.file.paste(pic) 
			archive[data] = file, pic, cnt

	prop 		= Template(file=self.file.template + "showarchive.tmpl")
	prop.lines	= archive
	self.req.write(prop)
	return

    def lastTen(self):	
	lastTen = {}
	unique 	= {}
	counter = 0
	path 	= self.file.template + 'last.txt'
	file 	= self.file.open(path)
	file.reverse()
	
	for fax in file:
	    if counter <= 9:
		info 			= self.file.open(fax[:-1])
		# change 5 into the lenght of your txtExt + 1
		pic 			= fax[:-5] + self.file.picExt
		pic			= self.file.split(pic)
		pic 			= self.file.paste(pic)
		lastTen[counter] 	= info
		unique[counter] 	= pic, fax
		counter 		= counter + 1		
	
	faxes		= Template(file=self.file.template + "lastten.tmpl")
	faxes.info 	= lastTen
	faxes.unique 	= unique
	faxes.counter	= counter
	self.req.write(faxes)	
	return
    
    def getDate(self, param, req):
	years = []
	months = []
	archive = {}
	if param['year'] == 'allyear':
	    years = self.file.listDir(self.file.backup)

	else:
	    years.append(param['year'])
	
	if param['month'] == 'allmonth':
	    cnt = 1
	    while cnt != 13:
		months.append(cnt)
		cnt = cnt + 1
	else:
	    months.append(param['month'])

	for year in years:
	    for month in months:
		if len(str(month)) == 1:
		    month = '0' + str(month)
		
		path = self.file.backup + str(year) + '/' + str(month) + '/'
		index = self.file.listDir(path)
		if index is not None:
		    self.file.changeDir(path)
		    file = self.file.isFile(index)
		    archive[path] = file
		else:
		    file = []
		    archive[path] = file
	
	self.show(archive)
	return


class Faxes:
    def __init__(self, req, File):
	self.req = req
	self.file = File
	
    def incoming(self):
	faxinfo 		= {}
	counter 		= 0
	files 			= self.file.listDir(self.file.temp)
	
	for tiff in files:
	    link 		= self.file.temp + tiff
	    # change 5 into the lenght of your picExt
	    txtFile 		= self.file.tempTxt + tiff[:-5] + self.file.txtExt
	    temptime		= self.file.open(txtFile)
	    self.file.changeDir(self.file.temp)
	    time 		= self.file.getTime(temptime[0])	    
	    path 		= self.file.backup + time[2] + '/' + time[1] + '/'
	    # change 5 into the lenght of your picExt
	    file 		= path + tiff[:-5] + self.file.txtExt
	    pic 		= self.file.web + time[2] + '/' + time[1] + '/' + tiff	    
	    lines 		= self.file.open(file)
	    faxinfo[counter] 	= lines[0], tiff, pic, file
	    counter 		= counter + 1
	
	list 		= Template(file=self.file.template + "incoming.tmpl")
	list.faxinfo 	= faxinfo
	self.req.write(list)
	return
	
    def add(self, file):
	for a, b  in self.req.params.items():
	    if b == 'pic':
		pic = a
	    elif b == 'Modify':
		pic = self.file.split(a)
		pict = self.file.paste(pic)
		# change 4 into the lenght of your txtExt
		pic = pict[:-4] + self.file.picExt
	
	lines 		= self.file.open(file)
	add 		= Template(file=self.file.template + "faxdata.tmpl")
	add.files 	= lines
	add.fax 	= file
	add.pic		= pic
	self.req.write(add)
	
	if 'Add' in self.req.params.values():
	    self.file.last(file, 0)
	
	return
	
    def save(self, param):
	fax 		= param['Faxfile']
	file 		= self.file.open(fax)
	self.file.save(file[0])
	return

    def removeFaxen(self, param):
	for key_a, value_a in param.items():
	    if value_a == 'on':
		for key_b, value_b in param.items():
		    if key_a == value_b:
			self.removeFax(key_b)
			
	return

    def removeFax(self, txt):
	# change 4 into the lenght of your txtExt
	pic = txt[:-4] + self.file.picExt
	dir = self.file.split(txt)
	rem = fax.Backup(fax.Faxes())
	rem.remove(pic, txt, dir)
	self.file.remove(pic)
	self.file.last(txt, 1)
	try:
	    self.deleteTemp(txt)
	except:
	    return
	return

    def deleteTemp(self, file):
	tiff 		= self.file.split(file)
	# change 4 into the lenght of your txtExt
	split 		= tiff[-1][:-4] + self.file.picExt
	self.file.remove(split)
	return


class Manager:

    def pressed(self, param):
	for a, b in param.items():
	    if b == 'Add' or b == 'Modify' or b == 'Remove':
		return a, b
	    
	    if a == 'Faxes' or a == 'save' or a == 'Submit' or a == 'Archief' or a == 'Properties' or a == 'Last' or a == 'Incoming':
		return a, b
	
	    else:
		link = a, b
	    
	return link


class File:
    def __init__(self, Path, param):
	self.backup 	= Path.backupPath
	self.temp 	= Path.tempPicPath
	self.template 	= Path.templatePath
	self.tempTxt	= Path.tempTxtPath
	self.web	= Path.web
	self.picExt	= Path.picExt
	self.txtExt	= Path.txtExt
	self.param	= param
    
    def open(self, file):
	content = open(file, 'r')
	lines 	= content.readlines()
	content.close()
	return lines
    
    def save(self, date):
	fax = open(self.param['Faxfile'], 'w')
	fax.write('%s' %date)
	fax.write('%s\n' %self.param['Phone'])
	fax.write('%s\n' %self.param['Sender'])
	fax.write('%s\n' %self.param['Subject'])
	fax.write('%s\n' %self.param['Description'])
	fax.close()
	return	

    def split(self, list):
	file = string.split(list, '/')
	return file

    def paste(self, pic):
	picture = pic[-4] + '/' + pic[-3] + '/' + pic[-2] + '/' + pic[-1] 
	return picture
    
    def changeDir(self, dir):
	os.chdir(dir)
	return

    def remove(self, tiff):
	path = self.temp + tiff
	# change 5 into the lenght of your picExt
	txt = self.tempTxt + tiff[:-5] + self.txtExt
	try:
	    os.remove(path)
	    os.remove(txt)
	except:
	    return
	return

    def listDir(self, dir):
	try:
	    list = os.listdir(dir)
	except:
	    list = None
	return list

    def isFile(self, dir):
	pic = []
	txt = []
	for fax in dir:
	    if os.path.isfile(fax):
		# change 5 into the lenght of your picExt
		if fax[-5:] == self.picExt:
		    pic.append(fax)
		else:
		    txt.append(fax)
	    
	return pic, txt

    def last(self, fileName, Last):
	path 	= self.template + 'last.txt'
	faxes 	= self.open(path)
	file 	= fileName + '\n'
	
	if Last == 0:    
	    if file not in faxes:
		faxes.append(file)
	else:
	    for fax in faxes:
		if file == fax:
		    faxes.remove(fax)
	
	file = open(path, 'w')
	
	for fax in faxes:
	    if fax != '\n':
		file.write(fax)
		
	file.close()
	return
		
    def getTime(self, tiff):
	time = string.split(tiff, ' ')
	return time
	

class Handler(cgi.Handler):
        
    def process(self, req):
        req.set_header("Content-Type", "text/html")
	param 		= req.params
	fax_module 	= fax.Faxes()
	myFile		= File(fax_module, param)
	myFax		= Faxes(req, myFile)
	myArchive 	= Archive(req, myFile)
	myManager	= Manager()	

	try:
	    get_prop 	= myManager.pressed(param)
	    if get_prop[1] == 'Add':
		myFax.add(get_prop[0])
		myFax.deleteTemp(get_prop[0])
		
	    elif get_prop[0] == 'Properties':
		myFax.save(param)
		myArchive.choose()
		myArchive.lastTen()
			    
	    elif get_prop[1] == 'Ok':
		if 'on' in param.values():
		    myFax.removeFaxen(param)
		myArchive.choose()
		myArchive.lastTen()

	    elif get_prop[1] == 'Modify':
		myFax.add(get_prop[0])

	    elif get_prop[0] == 'Faxes':
		myArchive.choose()
		myArchive.getDate(param, req)
		
	    elif get_prop[0] == 'Incoming':
		myArchive.choose()
		myFax.incoming()
		myArchive.lastTen()

	    elif get_prop[1] == 'Remove':
		myFax.removeFax(get_prop[0])
		myArchive.choose()
		myArchive.lastTen()
		
	    else:
		myArchive.choose()
		myArchive.lastTen()
	    
	except:
	    myArchive.choose()
	    myFax.incoming()
	    myArchive.lastTen()

cgi.CGIRequest(Handler).process()
